#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire300one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire300one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one3004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                                    
# -------------------------------------------------------------------------------------------------
# 300
# -------------------------------------------------------------------------------------------------                                          
shot2one3004xi = {
                  1:'0x0y299z',
                  2:'0x12y299z',
                  3:'0x198y224z',
                  4:'0x270y130z',
                  5:'0x38y297z',
                  6:'0x3y299z',
                  7:'0x6y299z',
                  8:'0x9y299z',
                  9:'100x137y246z',
                  10:'100x215y183z',
                  11:'102x184y213z',
                  12:'104x236y151z',
                  13:'105x130y248z',
                  14:'105x250y127z',
                  15:'10x196y226z',
                  16:'110x122y250z',
                  17:'110x177y215z',
                  18:'110x207y186z',
                  19:'115x115y251z',
                  20:'116x229y154z',
                  21:'117x243y130z',
                  22:'118x169y217z',
                  23:'119x107y253z',
                  24:'11x9y299z',
                  25:'120x200y188z',
                  26:'122x99y255z',
                  27:'125x161y219z',
                  28:'125x91y256z',
                  29:'127x221y156z',
                  30:'129x192y190z',
                  31:'129x235y133z',
                  32:'132x152y221z',
                  33:'138x183y193z',
                  34:'138x213y159z',
                  35:'139x143y223z',
                  36:'13x268y133z',
                  37:'140x227y136z',
                  38:'144x134y225z',
                  39:'146x174y195z',
                  40:'148x204y162z',
                  41:'149x125y227z',
                  42:'151x218y138z',
                  43:'153x165y197z',
                  44:'154x116y229z',
                  45:'157x195y164z',
                  46:'158x106y231z',
                  47:'160x155y199z',
                  48:'162x209y141z',
                  49:'166x185y167z',
                  50:'167x145y202z',
                  51:'172x199y144z',
                  52:'173x135y204z',
                  53:'174x175y169z',
                  54:'178x124y206z',
                  55:'17x16y399z',
                  56:'17x248y166z',
                  57:'181x188y146z',
                  58:'182x164y172z',
                  59:'189x153y174z',
                  60:'189x178y149z',
                  61:'195x142y176z',
                  62:'197x166y151z',
                  63:'19x226y195z',
                  64:'1x2y299z',
                  65:'1x35y297z',
                  66:'204x155y154z',
                  67:'20x193y228z',
                  68:'23x277y111z',
                  69:'27x265y136z',
                  70:'2x0y299z',
                  71:'2x32y298z',
                  72:'30x189y230z',
                  73:'30x245y169z',
                  74:'31x223y197z',
                  75:'37x274y114z',
                  76:'39x185y232z',
                  77:'3x5y299z',
                  78:'41x262y138z',
                  79:'42x219y200z',
                  80:'42x242y171z',
                  81:'48x180y234z',
                  82:'4x251y164z',
                  83:'4x29y298z',
                  84:'4x7y299z',
                  85:'51x271y117z',
                  86:'53x214y202z',
                  87:'54x238y174z',
                  88:'54x258y141z',
                  89:'57x175y236z',
                  90:'5x0y299z',
                  91:'5x10y299z',
                  92:'5x13y299z',
                  93:'5x23y299z',
                  94:'5x26y298z',
                  95:'64x209y204z',
                  96:'65x170y238z',
                  97:'65x267y119z',
                  98:'66x233y176z',
                  99:'67x254y144z',
                  100:'6x16y299z',
                  101:'6x20y299z',
                  102:'73x164y239z',
                  103:'74x204y206z',
                  104:'78x227y178z',
                  105:'79x262y122z',
                  106:'80x158y241z',
                  107:'80x249y146z',
                  108:'84x198y208z',
                  109:'87x151y243z',
                  110:'89x221y181z',
                  111:'8x0y299z',
                  112:'8x229y193z',
                  113:'8x279y108z',
                  114:'92x243y149z',
                  115:'92x256y125z',
                  116:'93x191y211z',
                  117:'94x144y245z',
                  118:'9x7y299z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire300one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire300one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE300ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE300ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE300ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE300ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE300ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE3004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one3004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE300ONE4XI - SUCCEEDED TO PUT SHOT2ONE3004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE3004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE300ONE4XI *** FAILED TO PUT SHOT2ONE3004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE300ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        # 
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one3004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one3004xi</nack2put4xi>" 
                     
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------

        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE300ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one3004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
        
    except:
        print(" (STEP 3C/33) OF FIRE300ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE300ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire300one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
